static char *cvs_id =" $Id: edf_lib.c,v 1.3 2005/03/24 15:52:50 berar Exp $ ";
/*  edf_lib : esrf data format  */
/*  jf berar */
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <errno.h>
/*-----------------------------------------------------------*/
#include "edf_def.h"
/*-----------------------------------------------------------*/
XY_HDR   *edf_gethdr (FILE *f);    
void    edf_hdrfill( FILE *f, XY_HDR *h);
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/* read edf file header and seek to its end                  */
#define BUF_LG 255
XY_HDR *edf_gethdr( FILE *f )
{   char *c, *d, buffer[BUF_LG+1];
    XY_HDR  *h;
    SWAP16  swaptest;
    
    fgets(buffer, BUF_LG, f);
    if (buffer[0] != '{' ) V_ERROR("header indentifier error\n");
    h = (XY_HDR *) malloc(sizeof(XY_HDR));
    memset(h, 0, sizeof(XY_HDR));
    h->t_data = INVALID_DATA;
    h->edf_disp = h->edf_used = 0;
    do
    {    fgets(buffer, BUF_LG, f);
         if ( feof(f)) V_ERROR("file end in the header\n");
         c = buffer;
         while (*c==' ') c++;
         if (*c == '}') break;
         if ( *c == 0 ) continue;
         d = c;
         while (*d != '=' && *d != 0) d++;
         if ( *d == '=') { *d = 0; d++ ; } else d = "";
         if (strstr(c, "Image"))  sscanf(d, "%d", &h->frames);
         else if (strstr(c, "ByteOrder"))
         {    swaptest.brut = 0x7fff;
              if (strstr(d, "HighByteFirst"))
              {  if ( swaptest.c.h == 0xff ) xy_setswapon();
                 else xy_setswapoff();
                 }
              else if (strstr(d, "LowByteFirst"))
              {  if ( swaptest.c.h == 0xff ) xy_setswapoff();
                 else xy_setswapon();
                 }
              else v_error(__FILE__, "unknown ByteOrder %s\n", d);
              }
         else if (strstr(c, "DataType"))
         {    if (strstr(d, "UnsignedShort")) h->t_data = T_INT16U;
              if (strstr(d, "SignedInteger")) h->t_data = T_INT32;
              if (strstr(d, "FloatValue")) h->t_data = T_FLOAT;
              }
         else if (strstr(c, "Dim_1"))  sscanf(d, "%hd", &h->x_dim);
         else if (strstr(c, "Dim_2"))  sscanf(d, "%hd", &h->y_dim);
         } while (!feof(f));
    h->header_end = ftell(f);
    return h;    
    }
/*-----------------------------------------------------------*/
void    edf_hdrfill( FILE *f, XY_HDR *h)
{   char *c, *d, *e, buffer[BUF_LG+1];
    fseek(f, 0, 0);
    fgets(buffer, BUF_LG, f);
    if (buffer[0] != '{' ) V_ERROR("header indentifier error\n");
    do
    {    fgets(buffer, BUF_LG, f); 
         buffer[BUF_LG] =0;
	 if ( feof(f)) V_ERROR("file end in the header\n");
         c = buffer;
         while (*c==' ') c++;
         if (*c == '}') break;
         if ( *c == 0 ) continue;
	 e = c + strlen(c) -1;
         while ((e != c ) && ( *e == ' ' || *e == '\n' || *e == '\r' || *e == ';' )) e--;
         if ( e != c) *(e+1) = 0; else continue;
         d = c;
         while (*d != '=' && *d != 0) d++;
         if ( *d == '=') { *d = 0; d++ ; } else d = "";
         xy_edfstr(h, c, d);
         } while (!feof(f));
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
XY_HDR  *edf_fopen (FILE *f, int quick, char * buffer) 
{   XY_HDR *h;
    h = edf_gethdr( f );
    if (h->t_data != T_INT16U || quick == 0 )
    {    edf_hdrfill(f , h);
         }
    h->name = str_alloc(buffer);
	 h->xy_mode = EDF_XYMODE;
    h->file = f;
    return h;
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/* for direct compatibility with wv2ph, direct acces function 
/* recupere une image depuis la position courante du fichier */
int edf_getraw(XY_HDR *h, IMAGE *img, void *val, int pos)
{   int  i, j, k, xread, xseek, xfor, yfor, size;
    long   p;
    INT32    *vl;
    INT16U   *vu;
    float    *vf;
    char     *v;
   switch  (h->t_data)
   {  case T_INT16U : size = sizeof(INT16U);  break;
      case T_INT32  : size = sizeof(INT32);  break;
      case T_FLOAT  : size = sizeof(float);  break;
      }
   p = img->header->header_end+ size * ( (pos-1) * img->osize
           + img->y_omin * img->x_osize + img->x_omin );
   xread=size*img->x_tsize;
   xseek=size*img->x_osize;
   xfor=img->x_tsize;
   yfor=img->y_tsize;
   for ( k=0, vu=val, vf=val; k<yfor; k++, vu+=xfor, vf+=xfor, p+=xseek )
   {   fseek( h->file, p, 0);
       switch  (h->t_data)
       {  case T_INT16U : vu = (INT16U *) val + k * xfor;  
                          v = (char *) vu;  break;
          case T_INT32  : vl = (INT32 *) val + k * xfor;  
                          v = (char *) vl;  break;
          case T_FLOAT  : vf = (float *) val + k * xfor;  
                          v = (char *) vf;  break;
          }
       if ( (j=fread( v, xread, 1, h->file)) != 1 )
       if ( k == 0 )  return 0;
       else
       {   fprintf(stderr, "EDFGETRAW error %d reading %d image at y = %d, y_min %d, pos %d\n",
                  errno, j, k+img->y_omin, img->y_omin, pos);
           return -1;
           }
       if (xy_doswap)  switch  (h->t_data)
       {  case T_INT16U : for (i=0; i < xfor; i++) xy_eswap16 (vu+i);
                          break;
          case T_INT32  : for (i=0; i < xfor; i++) xy_eswap32 (vl+i);
                          break;
          case T_FLOAT  : for (i=0; i < xfor; i++) xy_eswap32 ((INT32 *) (vf+i));
                          break;
          }
       }   
   return img->y_tsize;    
   }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
extern char * prg_name;
extern char * RELEASE;
void     edf_write  (IMAGE *img, T_DATA cas)
{   int i, j;
    char fname[256];
    XY_HDR *h;
    XY_EDF *p;
    FILE *fout, *f_hdr;
    SWAP16  swaptest;
    INT32   *ival, *iv;
    FLOAT64 *fval;
    float   *v;
    char *s, *c;
    int pos;
    int is_float = xy_isfloat(img);
    
    strcpy(fname, img->name);
    if (strstr(fname, ".edf") == NULL) strcat(fname, ".edf");
    prg_printf(" %s\n", fname);
    fout = fopen(fname, "wb");
    h = img->header;
    if ( fout == NULL ) v_error(__FILE__, "unable to open the edf out file : %s\n", fname);
    p = h->edf;
    fprintf(fout, "{\n" );
    fprintf( fout, "%-15s = %s ; \n", "HeaderID", "EH:000001:000000:000000"); 
    swaptest.brut = 0x7fff;
    fprintf( fout, "%-15s = %s ; \n", "ByteOrder", swaptest.c.h == 0xff ? "LowByteFirst":"HighByteFirst"); 
    switch (cas)
    { case T_FLOAT : 
           fprintf( fout, "%-15s = %s ; \n", "DataType", "FloatValue");
           v = (float *) malloc(sizeof(float)*img->x_size);
           break;
      default: 
           fprintf( fout, "%-15s = %s ; \n", "DataType", "SignedInteger");
      } 
    fprintf( fout, "%-15s = %ld ; \n", "Size", img->size * sizeof(INT32)); 
    fprintf( fout, "%-15s = %hd ; \n", "Dim_1", img->x_size); 
    fprintf( fout, "%-15s = %hd ; \n", "Dim_2", img->y_size); 
    fprintf( fout, "%-15s = %d ; \n", "Image", 1); 
    strcpy(fname, prg_name);
    strcat(fname, ".hdr");
    c = strrchr(fname, '/');
    if ( c == NULL) c = fname;
    f_hdr = fopen(c, "r");
    if (f_hdr != NULL )
    {  prg_printf (" adding %s contents to edf header\n", c);
       while (!feof(f_hdr))
       {  i = fread( fname, 1, sizeof(fname),f_hdr);
          if (i) fwrite( fname, 1, i,fout);
          }
        }
    else  prg_printf (" no  %s file to add to edf header\n", c);
    for ( i=0; i < h->edf_used; i ++, p++ )
    {   if (strstr(p->key, "HeaderID" ) != NULL ) continue;
        if (strstr(p->key, "ByteOrder" ) != NULL ) continue;
        if (strstr(p->key, "Dim_1" ) != NULL ) continue;
        if (strstr(p->key, "Dim_2" ) != NULL ) continue;
        if (strstr(p->key, "DataType" ) != NULL)  continue;
        if (strstr(p->key, "Size" ) != NULL)  continue;
        if (strstr(p->key, "Image" ) != NULL ) 
        {    fprintf( fout, "%-15s = %s ; \n", "Added_images", p->string);
             continue;
             }
        fprintf( fout, "%-15s = %s ; \n", p->key, p->string); 
        }
    fprintf( fout, "%-15s = %s ; \n", prg_name, RELEASE); 
    s ="fit2d_start = % 5d ;\n";
    pos = ftell(fout) + strlen(s) +6;
    pos = 1+ pos /1024;
    fprintf(fout, s, pos*1024 +1 );
    pos = ftell(fout);
    pos = (pos+3) % 1024;
    while (pos++<1024) fprintf(fout, " " );
    fprintf(fout, "\n}\n" );
    if (is_float) fval = img->data.f;
    else          ival = img->data.i; 
    if (is_float && cas != T_FLOAT ) iv = (INT32 *) malloc(sizeof(INT32)*img->x_size);
    for ( i=0; i < img->y_size; i++ , ival += img->x_size, fval += img->x_size)
    {  switch (cas)
       {  case T_FLOAT : 
            if (is_float) { for ( j=0; j< img->x_size; j++ ) v[j] = fval[j];}
            else          { for ( j=0; j< img->x_size; j++ ) v[j] = ival[j];}
            if ( fwrite( v, sizeof(float), img->x_size, fout) != img->x_size )
               V_ERROR("writing data in edf file\n");
            break;
          default: 
            if (is_float) { for ( j=0; j< img->x_size; j++ ) iv[j] = fval[j];}
            else  iv=ival;
            if ( fwrite( iv, sizeof(INT32), img->x_size, fout) != img->x_size )
            V_ERROR("writing data in edf file\n");
       }   } 
        if ( fclose (fout) ) V_ERROR("closing edf data file\n");
    prg_printf(" end edf_write %s\n", c);
    if (is_float && cas != T_FLOAT ) free(iv);
    switch (cas)
    {   case T_FLOAT : free(v); break;
        default : break;
        }
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/

